### 基本使用
> 可以配置自定义主题 也可以使用默认主题
#### 默认主题
```dart
void main() {
  runApp(VantUI(child: MyApp()));
}

// 省略MyApp方法

class DemoCell extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Color(0xfff7f8fa),
      appBar: AppBar(title: Text("Cell")),
      body: Scrollbar(
          child: ListView(
        children: <Widget>[
          VanCell(title: "单元格",value: "内容"),

          VanTag(text: "标签", closeable: true),
        ],
      )),
    );
  }
}
```
#### 自定义主题
```dart
void main() {
  runApp(
    VantUI(
      child: MyApp(),
      theme: VantThemeData(
        tag: VantTag(tagPrimaryColor: Color(0xff000000)),
        cell: VantCell(cellTextColor: Colors.red),
      ),
    ),
  );
}
```

### 设计资源
https://youzan.github.io/vant/#/zh-CN/design

### 正在开发中.. 欢迎有意向的小伙伴加入!!!!

### 预览图

| 组件名称  | ios | android |
|------|:-:|:-:|
| Cell  | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/cell/ios.png">| <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/cell/android.jpg"> |
| Tag | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/tag/ios.png"> | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/tag/android.jpg"> |
| Button | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/button/ios.png"> | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/button/android.jpg"> |
| Field |<img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/field/ios.png"> | <img src="https://raw.githubusercontent.com/lihaotian0607/flutter_vant/master/resources/field/android.jpg"> |
