import 'package:flutter/material.dart';
import 'package:vant/vant.dart';

class DemoButton extends StatefulWidget {
  @override
  _DemoButtonState createState() => _DemoButtonState();
}



class _DemoButtonState extends State<DemoButton> {
  bool loading = false;
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text("Button")),
      body: Scrollbar(
        child: ListView(
          children: <Widget>[
            Container(child: Text("按钮类型",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 5)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[
                VanButton(
                  label: "默认按钮",
                  onPressed: () {},
                ),

                VanButton(
                  label: "主要按钮",
                  onPressed: () {},
                  type: ButtonType.primary,
                ),

                VanButton(
                  label: "信息按钮",
                  onPressed: () {},
                  type: ButtonType.info,
                ),

                VanButton(
                  label: "危险按钮",
                  onPressed: () {},
                  type: ButtonType.danger,
                ),

                VanButton(
                  label: "警告按钮",
                  onPressed: () {},
                  type: ButtonType.warning,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("朴素按钮",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  label: "朴素按钮",
                  onPressed: () {},
                  type: ButtonType.primary,
                  plain: true,
                ),

                VanButton(
                  label: "朴素按钮",
                  onPressed: () {},
                  type: ButtonType.info,
                  plain: true,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("细边框",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  label: "细边框按钮",
                  onPressed: () {},
                  type: ButtonType.primary,
                  hairline: true,
                  plain: true,
                ),

                VanButton(
                  label: "细边框按钮",
                  onPressed: () {},
                  type: ButtonType.info,
                  hairline: true,
                  plain: true,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("禁用状态",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  label: "禁用状态",
                  onPressed: () {},
                  type: ButtonType.primary,
                ),

                VanButton(
                  label: "禁用状态",
                  onPressed: () {},
                  type: ButtonType.info,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("加载状态",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  loading: true,
                  onPressed: () {},
                  type: ButtonType.primary,
                ),

                VanButton(
                  label: "加载中...",
                  loading: true,
                  onPressed: () {},
                  type: ButtonType.info,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("按钮形状",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  label: "方形按钮",
                  onPressed: () {},
                  type: ButtonType.primary,
                  square: true,
                ),

                VanButton(
                  label: "圆形按钮",
                  onPressed: () {},
                  type: ButtonType.info,
                  round: true,
                ),

                VanButton(
                  icon: Icon(Icons.access_alarm,size: 15),
                  onPressed: () {},
                  type: ButtonType.info,
                  round: true,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("按钮图标",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  onPressed: () {},
                  type: ButtonType.primary,
                  icon: Icon(Icons.star_border,color: Colors.white),
                ),

                VanButton(
                  label: "按钮",
                  onPressed: () {},
                  icon: Icon(Icons.star_border,color: Colors.white),
                  type: ButtonType.primary,
                ),

                VanButton(
                  label: "按钮",
                  plain: true,
                  onPressed: () {},
                  icon: Icon(Icons.star_border,color: Colors.green),
                  type: ButtonType.primary,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),

            Container(child: Text("块级按钮",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: VanButton(
              onPressed: () {},
              type: ButtonType.primary,
              label: "块级按钮",
            ),padding: EdgeInsets.only(left: 8,right: 8)),


            Container(child: Text("自定义颜色",style: TextStyle(color: Colors.grey)),padding: EdgeInsets.only(left: 8,right: 8,bottom: 5,top: 20)),
            Container(child: Wrap(
              spacing: 8.0,
              runSpacing: 4.0,
              children: <Widget>[

                VanButton(
                  color: Colors.purple,
                  label:"单色按钮",
                  labelColor: Colors.white,
                  onPressed: () {},
                ),

                VanButton(
                  label:"单色按钮",
                  onPressed: () {},
                  plain: true,
                  color: Colors.purple,
                ),

                VanButton(
                  label:"单色按钮",
                  onPressed: () {},
                  plain: true,
                  color: Colors.purple,
                ),
              ],
            ),padding: EdgeInsets.only(left: 8,right: 8)),
          ],
        ),
      ),
    );
  }
}
