import 'package:flutter/material.dart';
import 'package:vant/vant.dart';

class DemoTag extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Color(0xfff7f8fa),
      appBar: AppBar(title: Text("Tag")),
      body: Padding(
        padding: EdgeInsets.only(left: 10, right: 10),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          crossAxisAlignment: CrossAxisAlignment.start,
          children: <Widget>[
            Text("基础用法",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签"),
                  VanTag(text: "标签", type: TagType.primary),
                  VanTag(text: "标签", type: TagType.success),
                  VanTag(text: "标签", type: TagType.danger),
                  VanTag(text: "标签", type: TagType.warning),
                ],
              ),
            ),
            Text("圆角样式",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签", round: true),
                  VanTag(text: "标签", round: true, type: TagType.primary),
                  VanTag(text: "标签", round: true, type: TagType.success),
                  VanTag(text: "标签", round: true, type: TagType.danger),
                  VanTag(text: "标签", round: true, type: TagType.warning),
                ],
              ),
            ),
            Text("标记样式",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签", mark: true),
                  VanTag(text: "标签", mark: true, type: TagType.primary),
                  VanTag(text: "标签", mark: true, type: TagType.success),
                  VanTag(text: "标签", mark: true, type: TagType.danger),
                  VanTag(text: "标签", mark: true, type: TagType.warning),
                ],
              ),
            ),
            Text("空心样式",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签", plain: true),
                  VanTag(text: "标签", plain: true, type: TagType.primary),
                  VanTag(text: "标签", plain: true, type: TagType.success),
                  VanTag(text: "标签", plain: true, type: TagType.danger),
                  VanTag(text: "标签", plain: true, type: TagType.warning),
                ],
              ),
            ),
            Text("标签大小",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签"),
                  VanTag(
                      text: "标签", size: TagSize.medium, type: TagType.primary),
                  VanTag(
                      text: "标签", size: TagSize.large, type: TagType.success),
                  VanTag(
                      text: "标签", size: TagSize.medium, type: TagType.danger),
                  VanTag(text: "标签", type: TagType.warning),
                ],
              ),
            ),
            Text("可关闭标签",style: TextStyle(color: Color(0xff969799))),
            Padding(
              padding: EdgeInsets.only(top: 10, bottom: 10),
              child: Wrap(
                spacing: 10.0,
                runSpacing: 4.0,
                children: <Widget>[
                  VanTag(text: "标签", closeable: true),
                  VanTag(text: "标签", closeable: true, type: TagType.primary),
                  VanTag(text: "标签", closeable: true, type: TagType.success),
                  VanTag(text: "标签", closeable: true, type: TagType.danger),
                  VanTag(text: "标签", closeable: true, type: TagType.warning),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
