import 'package:flutter/material.dart';

class VantBasicTheme {
  final Color borderColor;
  final double borderWidthBase;
  final double borderRadiusSm;
  final double borderRadiusMd;
  final double borderRadiusLg;
  final double borderRadiusMax;

  @override
  String toString() {
    return 'VantBasic{borderColor: $borderColor, borderWidthBase: $borderWidthBase, borderRadiusSm: $borderRadiusSm, borderRadiusMd: $borderRadiusMd, borderRadiusLg: $borderRadiusLg, borderRadiusMax: $borderRadiusMax}';
  }

  const VantBasicTheme({
    @required this.borderColor,
    @required this.borderWidthBase,
    @required this.borderRadiusSm,
    @required this.borderRadiusMd,
    @required this.borderRadiusLg,
    @required this.borderRadiusMax,
  });

  VantBasicTheme copyWith({
    Color borderColor,
    double borderWidthBase,
    double borderRadiusSm,
    double borderRadiusMd,
    double borderRadiusLg,
    double borderRadiusMax,
  }) {
    if ((borderColor == null || identical(borderColor, this.borderColor)) &&
        (borderWidthBase == null ||
            identical(borderWidthBase, this.borderWidthBase)) &&
        (borderRadiusSm == null ||
            identical(borderRadiusSm, this.borderRadiusSm)) &&
        (borderRadiusMd == null ||
            identical(borderRadiusMd, this.borderRadiusMd)) &&
        (borderRadiusLg == null ||
            identical(borderRadiusLg, this.borderRadiusLg)) &&
        (borderRadiusMax == null ||
            identical(borderRadiusMax, this.borderRadiusMax))) {
      return this;
    }

    return new VantBasicTheme(
      borderColor: borderColor ?? this.borderColor,
      borderWidthBase: borderWidthBase ?? this.borderWidthBase,
      borderRadiusSm: borderRadiusSm ?? this.borderRadiusSm,
      borderRadiusMd: borderRadiusMd ?? this.borderRadiusMd,
      borderRadiusLg: borderRadiusLg ?? this.borderRadiusLg,
      borderRadiusMax: borderRadiusMax ?? this.borderRadiusMax,
    );
  }
}
