import 'package:flutter/material.dart';

enum ButtonType { primary, info, warning, danger }

enum ButtonSize { large, small, mini }

class VantButtonTheme {
  final double buttonMiniHeight;
  final double buttonMiniFontSize;
  final double buttonSmallHeight;
  final double buttonSmallFontSize;

  final double buttonNormalFontSize;
  final double buttonLargeHeight;
  final double buttonDefaultHeight;
  final double buttonDefaultLineHeight;

  final double buttonDefaultFontSize;
  final Color buttonDefaultColor;
  final Color buttonDefaultBackgroundColor;
  final Color buttonDefaultBorderColor;
  final Color buttonPrimaryColor;
  final Color buttonPrimaryBackgroundColor;

  final Color buttonPrimaryBorderColor;
  final Color buttonInfoColor;
  final Color buttonInfoBackgroundColor;
  final Color buttonInfoBorderColor;

  final Color buttonDangerColor;
  final Color buttonDangerBackgroundColor;
  final Color buttonDangerBorderColor;

  final Color buttonWarningColor;
  final Color buttonWarningBackgroundColor;
  final Color buttonWarningBorderColor;

  final double buttonBorderWidth;
  final double buttonHairBorderWidth;
  final double buttonBorderRadius;

  final double buttonRoundBorderRadius;
  final Color buttonPlainBackgroundColor;
  final double buttonDisabledOpacity;

  VantButtonTheme({
    this.buttonMiniHeight,
    this.buttonHairBorderWidth,
    this.buttonMiniFontSize,
    this.buttonSmallHeight,
    this.buttonSmallFontSize,
    this.buttonNormalFontSize,
    this.buttonLargeHeight,
    this.buttonDefaultHeight,
    this.buttonDefaultLineHeight,
    this.buttonDefaultFontSize,
    this.buttonDefaultColor,
    this.buttonDefaultBackgroundColor,
    this.buttonDefaultBorderColor,
    this.buttonPrimaryColor,
    this.buttonPrimaryBackgroundColor,
    this.buttonPrimaryBorderColor,
    this.buttonInfoColor,
    this.buttonInfoBackgroundColor,
    this.buttonInfoBorderColor,
    this.buttonDangerColor,
    this.buttonDangerBackgroundColor,
    this.buttonDangerBorderColor,
    this.buttonWarningColor,
    this.buttonWarningBackgroundColor,
    this.buttonWarningBorderColor,
    this.buttonBorderWidth,
    this.buttonBorderRadius,
    this.buttonRoundBorderRadius,
    this.buttonPlainBackgroundColor,
    this.buttonDisabledOpacity,
  });

  VantButtonTheme copyWith({
    double buttonMiniHeight,
    double buttonMiniFontSize,
    double buttonSmallHeight,
    double buttonSmallFontSize,
    double buttonNormalFontSize,
    double buttonLargeHeight,
    double buttonDefaultHeight,
    double buttonDefaultLineHeight,
    double buttonDefaultFontSize,
    Color buttonDefaultColor,
    Color buttonDefaultBackgroundColor,
    Color buttonDefaultBorderColor,
    Color buttonPrimaryColor,
    Color buttonPrimaryBackgroundColor,
    Color buttonPrimaryBorderColor,
    Color buttonInfoColor,
    Color buttonInfoBackgroundColor,
    Color buttonInfoBorderColor,
    Color buttonDangerColor,
    Color buttonDangerBackgroundColor,
    Color buttonDangerBorderColor,
    Color buttonWarningColor,
    Color buttonWarningBackgroundColor,
    Color buttonWarningBorderColor,
    double buttonBorderWidth,
    double buttonHairBorderWidth,
    double buttonBorderRadius,
    double buttonRoundBorderRadius,
    Color buttonPlainBackgroundColor,
    double buttonDisabledOpacity,
  }) {
    if ((buttonMiniHeight == null ||
            identical(buttonMiniHeight, this.buttonMiniHeight)) &&
        (buttonMiniFontSize == null ||
            identical(buttonMiniFontSize, this.buttonMiniFontSize)) &&
        (buttonSmallHeight == null ||
            identical(buttonSmallHeight, this.buttonSmallHeight)) &&
        (buttonSmallFontSize == null ||
            identical(buttonSmallFontSize, this.buttonSmallFontSize)) &&
        (buttonNormalFontSize == null ||
            identical(buttonNormalFontSize, this.buttonNormalFontSize)) &&
        (buttonLargeHeight == null ||
            identical(buttonLargeHeight, this.buttonLargeHeight)) &&
        (buttonDefaultHeight == null ||
            identical(buttonDefaultHeight, this.buttonDefaultHeight)) &&
        (buttonDefaultLineHeight == null ||
            identical(buttonDefaultLineHeight, this.buttonDefaultLineHeight)) &&
        (buttonDefaultFontSize == null ||
            identical(buttonDefaultFontSize, this.buttonDefaultFontSize)) &&
        (buttonDefaultColor == null ||
            identical(buttonDefaultColor, this.buttonDefaultColor)) &&
        (buttonDefaultBackgroundColor == null ||
            identical(buttonDefaultBackgroundColor,
                this.buttonDefaultBackgroundColor)) &&
        (buttonDefaultBorderColor == null ||
            identical(
                buttonDefaultBorderColor, this.buttonDefaultBorderColor)) &&
        (buttonPrimaryColor == null ||
            identical(buttonPrimaryColor, this.buttonPrimaryColor)) &&
        (buttonPrimaryBackgroundColor == null ||
            identical(buttonPrimaryBackgroundColor,
                this.buttonPrimaryBackgroundColor)) &&
        (buttonPrimaryBorderColor == null ||
            identical(
                buttonPrimaryBorderColor, this.buttonPrimaryBorderColor)) &&
        (buttonInfoColor == null ||
            identical(buttonInfoColor, this.buttonInfoColor)) &&
        (buttonInfoBackgroundColor == null ||
            identical(
                buttonInfoBackgroundColor, this.buttonInfoBackgroundColor)) &&
        (buttonInfoBorderColor == null ||
            identical(buttonInfoBorderColor, this.buttonInfoBorderColor)) &&
        (buttonDangerColor == null ||
            identical(buttonDangerColor, this.buttonDangerColor)) &&
        (buttonDangerBackgroundColor == null ||
            identical(buttonDangerBackgroundColor,
                this.buttonDangerBackgroundColor)) &&
        (buttonDangerBorderColor == null ||
            identical(buttonDangerBorderColor, this.buttonDangerBorderColor)) &&
        (buttonWarningColor == null ||
            identical(buttonWarningColor, this.buttonWarningColor)) &&
        (buttonWarningBackgroundColor == null ||
            identical(buttonWarningBackgroundColor,
                this.buttonWarningBackgroundColor)) &&
        (buttonWarningBorderColor == null ||
            identical(
                buttonWarningBorderColor, this.buttonWarningBorderColor)) &&
        (buttonBorderWidth == null ||
            identical(buttonBorderWidth, this.buttonBorderWidth)) &&
        (buttonHairBorderWidth == null ||
            identical(buttonHairBorderWidth, this.buttonHairBorderWidth)) &&
        (buttonBorderRadius == null ||
            identical(buttonBorderRadius, this.buttonBorderRadius)) &&
        (buttonRoundBorderRadius == null ||
            identical(buttonRoundBorderRadius, this.buttonRoundBorderRadius)) &&
        (buttonPlainBackgroundColor == null ||
            identical(
                buttonPlainBackgroundColor, this.buttonPlainBackgroundColor)) &&
        (buttonDisabledOpacity == null ||
            identical(buttonDisabledOpacity, this.buttonDisabledOpacity))) {
      return this;
    }

    return new VantButtonTheme(
      buttonMiniHeight: buttonMiniHeight ?? this.buttonMiniHeight,
      buttonMiniFontSize: buttonMiniFontSize ?? this.buttonMiniFontSize,
      buttonSmallHeight: buttonSmallHeight ?? this.buttonSmallHeight,
      buttonSmallFontSize: buttonSmallFontSize ?? this.buttonSmallFontSize,
      buttonNormalFontSize: buttonNormalFontSize ?? this.buttonNormalFontSize,
      buttonLargeHeight: buttonLargeHeight ?? this.buttonLargeHeight,
      buttonDefaultHeight: buttonDefaultHeight ?? this.buttonDefaultHeight,
      buttonDefaultLineHeight:
          buttonDefaultLineHeight ?? this.buttonDefaultLineHeight,
      buttonDefaultFontSize:
          buttonDefaultFontSize ?? this.buttonDefaultFontSize,
      buttonDefaultColor: buttonDefaultColor ?? this.buttonDefaultColor,
      buttonDefaultBackgroundColor:
          buttonDefaultBackgroundColor ?? this.buttonDefaultBackgroundColor,
      buttonDefaultBorderColor:
          buttonDefaultBorderColor ?? this.buttonDefaultBorderColor,
      buttonPrimaryColor: buttonPrimaryColor ?? this.buttonPrimaryColor,
      buttonPrimaryBackgroundColor:
          buttonPrimaryBackgroundColor ?? this.buttonPrimaryBackgroundColor,
      buttonPrimaryBorderColor:
          buttonPrimaryBorderColor ?? this.buttonPrimaryBorderColor,
      buttonInfoColor: buttonInfoColor ?? this.buttonInfoColor,
      buttonInfoBackgroundColor:
          buttonInfoBackgroundColor ?? this.buttonInfoBackgroundColor,
      buttonInfoBorderColor:
          buttonInfoBorderColor ?? this.buttonInfoBorderColor,
      buttonDangerColor: buttonDangerColor ?? this.buttonDangerColor,
      buttonDangerBackgroundColor:
          buttonDangerBackgroundColor ?? this.buttonDangerBackgroundColor,
      buttonDangerBorderColor:
          buttonDangerBorderColor ?? this.buttonDangerBorderColor,
      buttonWarningColor: buttonWarningColor ?? this.buttonWarningColor,
      buttonWarningBackgroundColor:
          buttonWarningBackgroundColor ?? this.buttonWarningBackgroundColor,
      buttonWarningBorderColor:
          buttonWarningBorderColor ?? this.buttonWarningBorderColor,
      buttonBorderWidth: buttonBorderWidth ?? this.buttonBorderWidth,
      buttonHairBorderWidth:
          buttonHairBorderWidth ?? this.buttonHairBorderWidth,
      buttonBorderRadius: buttonBorderRadius ?? this.buttonBorderRadius,
      buttonRoundBorderRadius:
          buttonRoundBorderRadius ?? this.buttonRoundBorderRadius,
      buttonPlainBackgroundColor:
          buttonPlainBackgroundColor ?? this.buttonPlainBackgroundColor,
      buttonDisabledOpacity:
          buttonDisabledOpacity ?? this.buttonDisabledOpacity,
    );
  }

  Color textColor(ButtonType type) {
    switch (type) {
      case ButtonType.info:
        return this.buttonInfoColor;
      case ButtonType.primary:
        return this.buttonPrimaryColor;
      case ButtonType.warning:
        return this.buttonWarningColor;
      case ButtonType.danger:
        return this.buttonDangerColor;
      default:
        return this.buttonDefaultColor;
    }
  }

  Color backgroundColor(ButtonType type) {
    switch (type) {
      case ButtonType.info:
        return this.buttonInfoBackgroundColor;
      case ButtonType.primary:
        return this.buttonPrimaryBackgroundColor;
      case ButtonType.warning:
        return this.buttonWarningBackgroundColor;
      case ButtonType.danger:
        return this.buttonDangerBackgroundColor;
      default:
        return this.buttonDefaultBackgroundColor;
    }
  }

  Color borderColor(ButtonType type) {
    switch (type) {
      case ButtonType.info:
        return this.buttonInfoBorderColor;
      case ButtonType.primary:
        return this.buttonPrimaryBorderColor;
      case ButtonType.warning:
        return this.buttonWarningBorderColor;
      case ButtonType.danger:
        return this.buttonDangerBorderColor;
      default:
        return this.buttonDefaultBorderColor;
    }
  }

  double fontSize(ButtonSize size) {
    switch (size) {
      case ButtonSize.large:
        return this.buttonNormalFontSize;
      case ButtonSize.small:
        return this.buttonSmallFontSize;
      case ButtonSize.mini:
        return this.buttonMiniFontSize;
      default:
        return this.buttonDefaultFontSize;
    }
  }

  EdgeInsets padding(ButtonSize size) {
    switch (size) {
      case ButtonSize.large:
        return EdgeInsets.symmetric(horizontal: 24);
      case ButtonSize.small:
        return EdgeInsets.symmetric(horizontal: 8);
      case ButtonSize.mini:
        return EdgeInsets.symmetric(horizontal: 2);
      default:
        return EdgeInsets.symmetric(horizontal: 15);
    }
  }

  double height(ButtonSize size) {
    switch (size) {
      case ButtonSize.large:
        return this.buttonLargeHeight;
      case ButtonSize.small:
        return this.buttonSmallHeight;
      case ButtonSize.mini:
        return this.buttonMiniHeight;
      default:
        return this.buttonDefaultHeight;
    }
  }
}
