import 'package:flutter/material.dart';

class VantCardTheme {
  final EdgeInsets cardPadding;
  final double cardFontSize;
  final Color cardTextColor;
  final Color cardBackgroundColor;
  final double cardThumbSize;
  final double cardThumbBorderRadius;
  final double cardTitleLineHeight;
  final Color cardDescColor;
  final double cardDescLineHeight;
  final Color cardPriceColor;
  final Color cardOriginPriceColor;
  final Color cardNumColor;
  final double cardOriginPriceFontSize;
  final double cardPriceFontSize;
  final double cardPriceIntegerFontSize;


  const VantCardTheme({
    @required this.cardPadding,
    @required this.cardFontSize,
    @required this.cardTextColor,
    @required this.cardBackgroundColor,
    @required this.cardThumbSize,
    @required this.cardThumbBorderRadius,
    @required this.cardTitleLineHeight,
    @required this.cardDescColor,
    @required this.cardDescLineHeight,
    @required this.cardPriceColor,
    @required this.cardOriginPriceColor,
    @required this.cardNumColor,
    @required this.cardOriginPriceFontSize,
    @required this.cardPriceFontSize,
    @required this.cardPriceIntegerFontSize,
  });

  VantCardTheme copyWith({
    EdgeInsets cardPadding,
    double cardFontSize,
    Color cardTextColor,
    Color cardBackgroundColor,
    double cardThumbSize,
    double cardThumbBorderRadius,
    double cardTitleLineHeight,
    Color cardDescColor,
    double cardDescLineHeight,
    Color cardPriceColor,
    Color cardOriginPriceColor,
    Color cardNumColor,
    double cardOriginPriceFontSize,
    double cardPriceFontSize,
    double cardPriceIntegerFontSize,
  }) {
    if ((cardPadding == null || identical(cardPadding, this.cardPadding)) &&
        (cardFontSize == null || identical(cardFontSize, this.cardFontSize)) &&
        (cardTextColor == null ||
            identical(cardTextColor, this.cardTextColor)) &&
        (cardBackgroundColor == null ||
            identical(cardBackgroundColor, this.cardBackgroundColor)) &&
        (cardThumbSize == null ||
            identical(cardThumbSize, this.cardThumbSize)) &&
        (cardThumbBorderRadius == null ||
            identical(cardThumbBorderRadius, this.cardThumbBorderRadius)) &&
        (cardTitleLineHeight == null ||
            identical(cardTitleLineHeight, this.cardTitleLineHeight)) &&
        (cardDescColor == null ||
            identical(cardDescColor, this.cardDescColor)) &&
        (cardDescLineHeight == null ||
            identical(cardDescLineHeight, this.cardDescLineHeight)) &&
        (cardPriceColor == null ||
            identical(cardPriceColor, this.cardPriceColor)) &&
        (cardOriginPriceColor == null ||
            identical(cardOriginPriceColor, this.cardOriginPriceColor)) &&
        (cardNumColor == null || identical(cardNumColor, this.cardNumColor)) &&
        (cardOriginPriceFontSize == null ||
            identical(cardOriginPriceFontSize, this.cardOriginPriceFontSize)) &&
        (cardPriceFontSize == null ||
            identical(cardPriceFontSize, this.cardPriceFontSize)) &&
        (cardPriceIntegerFontSize == null ||
            identical(
                cardPriceIntegerFontSize, this.cardPriceIntegerFontSize))) {
      return this;
    }

    return new VantCardTheme(
      cardPadding: cardPadding ?? this.cardPadding,
      cardFontSize: cardFontSize ?? this.cardFontSize,
      cardTextColor: cardTextColor ?? this.cardTextColor,
      cardBackgroundColor: cardBackgroundColor ?? this.cardBackgroundColor,
      cardThumbSize: cardThumbSize ?? this.cardThumbSize,
      cardThumbBorderRadius:
          cardThumbBorderRadius ?? this.cardThumbBorderRadius,
      cardTitleLineHeight: cardTitleLineHeight ?? this.cardTitleLineHeight,
      cardDescColor: cardDescColor ?? this.cardDescColor,
      cardDescLineHeight: cardDescLineHeight ?? this.cardDescLineHeight,
      cardPriceColor: cardPriceColor ?? this.cardPriceColor,
      cardOriginPriceColor: cardOriginPriceColor ?? this.cardOriginPriceColor,
      cardNumColor: cardNumColor ?? this.cardNumColor,
      cardOriginPriceFontSize:
          cardOriginPriceFontSize ?? this.cardOriginPriceFontSize,
      cardPriceFontSize: cardPriceFontSize ?? this.cardPriceFontSize,
      cardPriceIntegerFontSize:
          cardPriceIntegerFontSize ?? this.cardPriceIntegerFontSize,
    );
  }
}
