import 'package:flutter/cupertino.dart';

class VantCellTheme {
  final double cellFontSize;
  final double cellLineHeight;

  final double cellVerticalPadding;
  final double cellHorizontalPadding;
  final Color cellTextColor;
  final Color cellBackgroundColor;
  final Color cellBorderColor;
  final Color cellActiveColor;
  final Color cellRequiredColor;
  final Color cellLabelColor;
  final double cellLabelFontSize;
  final double cellLabelLineHeight;
  final double cellLabelMarginTop;
  final Color cellValueColor;

  final double cellIconSize;
  final Color cellRightIconColor;
  final double cellLargeVerticalPadding;
  final double cellLargeTitleFontSize;
  final double cellLargeLabelFontSize;

  const VantCellTheme({
    this.cellFontSize,
    this.cellLineHeight,
    this.cellVerticalPadding,
    this.cellHorizontalPadding,
    this.cellTextColor,
    this.cellBackgroundColor,
    this.cellBorderColor,
    this.cellActiveColor,
    this.cellRequiredColor,
    this.cellLabelColor,
    this.cellLabelFontSize,
    this.cellLabelLineHeight,
    this.cellLabelMarginTop,
    this.cellValueColor,
    this.cellIconSize,
    this.cellRightIconColor,
    this.cellLargeVerticalPadding,
    this.cellLargeTitleFontSize,
    this.cellLargeLabelFontSize,
  });

  VantCellTheme copyWith({
    double cellFontSize,
    double cellLineHeight,
    double cellVerticalPadding,
    double cellHorizontalPadding,
    Color cellTextColor,
    Color cellBackgroundColor,
    Color cellBorderColor,
    Color cellActiveColor,
    Color cellRequiredColor,
    Color cellLabelColor,
    double cellLabelFontSize,
    double cellLabelLineHeight,
    double cellLabelMarginTop,
    Color cellValueColor,
    double cellIconSize,
    Color cellRightIconColor,
    double cellLargeVerticalPadding,
    double cellLargeTitleFontSize,
    double cellLargeLabelFontSize,
  }) {
    if ((cellFontSize == null || identical(cellFontSize, this.cellFontSize)) &&
        (cellLineHeight == null ||
            identical(cellLineHeight, this.cellLineHeight)) &&
        (cellVerticalPadding == null ||
            identical(cellVerticalPadding, this.cellVerticalPadding)) &&
        (cellHorizontalPadding == null ||
            identical(cellHorizontalPadding, this.cellHorizontalPadding)) &&
        (cellTextColor == null ||
            identical(cellTextColor, this.cellTextColor)) &&
        (cellBackgroundColor == null ||
            identical(cellBackgroundColor, this.cellBackgroundColor)) &&
        (cellBorderColor == null ||
            identical(cellBorderColor, this.cellBorderColor)) &&
        (cellActiveColor == null ||
            identical(cellActiveColor, this.cellActiveColor)) &&
        (cellRequiredColor == null ||
            identical(cellRequiredColor, this.cellRequiredColor)) &&
        (cellLabelColor == null ||
            identical(cellLabelColor, this.cellLabelColor)) &&
        (cellLabelFontSize == null ||
            identical(cellLabelFontSize, this.cellLabelFontSize)) &&
        (cellLabelLineHeight == null ||
            identical(cellLabelLineHeight, this.cellLabelLineHeight)) &&
        (cellLabelMarginTop == null ||
            identical(cellLabelMarginTop, this.cellLabelMarginTop)) &&
        (cellValueColor == null ||
            identical(cellValueColor, this.cellValueColor)) &&
        (cellIconSize == null || identical(cellIconSize, this.cellIconSize)) &&
        (cellRightIconColor == null ||
            identical(cellRightIconColor, this.cellRightIconColor)) &&
        (cellLargeVerticalPadding == null ||
            identical(
                cellLargeVerticalPadding, this.cellLargeVerticalPadding)) &&
        (cellLargeTitleFontSize == null ||
            identical(cellLargeTitleFontSize, this.cellLargeTitleFontSize)) &&
        (cellLargeLabelFontSize == null ||
            identical(cellLargeLabelFontSize, this.cellLargeLabelFontSize))) {
      return this;
    }

    return new VantCellTheme(
      cellFontSize: cellFontSize ?? this.cellFontSize,
      cellLineHeight: cellLineHeight ?? this.cellLineHeight,
      cellVerticalPadding: cellVerticalPadding ?? this.cellVerticalPadding,
      cellHorizontalPadding:
          cellHorizontalPadding ?? this.cellHorizontalPadding,
      cellTextColor: cellTextColor ?? this.cellTextColor,
      cellBackgroundColor: cellBackgroundColor ?? this.cellBackgroundColor,
      cellBorderColor: cellBorderColor ?? this.cellBorderColor,
      cellActiveColor: cellActiveColor ?? this.cellActiveColor,
      cellRequiredColor: cellRequiredColor ?? this.cellRequiredColor,
      cellLabelColor: cellLabelColor ?? this.cellLabelColor,
      cellLabelFontSize: cellLabelFontSize ?? this.cellLabelFontSize,
      cellLabelLineHeight: cellLabelLineHeight ?? this.cellLabelLineHeight,
      cellLabelMarginTop: cellLabelMarginTop ?? this.cellLabelMarginTop,
      cellValueColor: cellValueColor ?? this.cellValueColor,
      cellIconSize: cellIconSize ?? this.cellIconSize,
      cellRightIconColor: cellRightIconColor ?? this.cellRightIconColor,
      cellLargeVerticalPadding:
          cellLargeVerticalPadding ?? this.cellLargeVerticalPadding,
      cellLargeTitleFontSize:
          cellLargeTitleFontSize ?? this.cellLargeTitleFontSize,
      cellLargeLabelFontSize:
          cellLargeLabelFontSize ?? this.cellLargeLabelFontSize,
    );
  }

  @override
  String toString() {
    return 'VantCell{cellFontSize: $cellFontSize, cellLineHeight: $cellLineHeight, cellVerticalPadding: $cellVerticalPadding, cellHorizontalPadding: $cellHorizontalPadding, cellTextColor: $cellTextColor, cellBackgroundColor: $cellBackgroundColor, cellBorderColor: $cellBorderColor, cellActiveColor: $cellActiveColor, cellRequiredColor: $cellRequiredColor, cellLabelColor: $cellLabelColor, cellLabelFontSize: $cellLabelFontSize, cellLabelLineHeight: $cellLabelLineHeight, cellLabelMarginTop: $cellLabelMarginTop, cellValueColor: $cellValueColor, cellIconSize: $cellIconSize, cellRightIconColor: $cellRightIconColor, cellLargeVerticalPadding: $cellLargeVerticalPadding, cellLargeTitleFontSize: $cellLargeTitleFontSize, cellLargeLabelFontSize: $cellLargeLabelFontSize}';
  }
}
