import 'package:flutter/material.dart';

class VantCellGroupTheme {
  final Color cellGroupBackgroundColor;
  final Color cellGroupTitleColor;
  final EdgeInsets cellGroupTitlePadding;
  final double cellGroupTitleFontSize;
  final double cellGroupTitleLineHeight;

  const VantCellGroupTheme({
    @required this.cellGroupBackgroundColor,
    @required this.cellGroupTitleColor,
    @required this.cellGroupTitlePadding,
    @required this.cellGroupTitleFontSize,
    @required this.cellGroupTitleLineHeight,
  });

  VantCellGroupTheme copyWith({
    Color cellGroupBackgroundColor,
    Color cellGroupTitleColor,
    EdgeInsets cellGroupTitlePadding,
    double cellGroupTitleFontSize,
    double cellGroupTitleLineHeight,
  }) {
    if ((cellGroupBackgroundColor == null ||
            identical(
                cellGroupBackgroundColor, this.cellGroupBackgroundColor)) &&
        (cellGroupTitleColor == null ||
            identical(cellGroupTitleColor, this.cellGroupTitleColor)) &&
        (cellGroupTitlePadding == null ||
            identical(cellGroupTitlePadding, this.cellGroupTitlePadding)) &&
        (cellGroupTitleFontSize == null ||
            identical(cellGroupTitleFontSize, this.cellGroupTitleFontSize)) &&
        (cellGroupTitleLineHeight == null ||
            identical(
                cellGroupTitleLineHeight, this.cellGroupTitleLineHeight))) {
      return this;
    }

    return new VantCellGroupTheme(
      cellGroupBackgroundColor:
          cellGroupBackgroundColor ?? this.cellGroupBackgroundColor,
      cellGroupTitleColor: cellGroupTitleColor ?? this.cellGroupTitleColor,
      cellGroupTitlePadding:
          cellGroupTitlePadding ?? this.cellGroupTitlePadding,
      cellGroupTitleFontSize:
          cellGroupTitleFontSize ?? this.cellGroupTitleFontSize,
      cellGroupTitleLineHeight:
          cellGroupTitleLineHeight ?? this.cellGroupTitleLineHeight,
    );
  }

  @override
  String toString() {
    return 'VantCellGroup{cellGroupBackgroundColor: $cellGroupBackgroundColor, cellGroupTitleColor: $cellGroupTitleColor, cellGroupTitlePadding: $cellGroupTitlePadding, cellGroupTitleFontSize: $cellGroupTitleFontSize, cellGroupTitleLineHeight: $cellGroupTitleLineHeight}';
  }
}
