import 'package:flutter/material.dart';

class VantCircleTheme {
  final Color circleTextColor;
  final double circleTextFontWeight;
  final double circleTextFontSize;
  final double circleTextLineHeight;

  const VantCircleTheme({
    @required this.circleTextColor,
    @required this.circleTextFontWeight,
    @required this.circleTextFontSize,
    @required this.circleTextLineHeight,
  });

  VantCircleTheme copyWith({
    Color circleTextColor,
    double circleTextFontWeight,
    double circleTextFontSize,
    double circleTextLineHeight,
  }) {
    if ((circleTextColor == null ||
            identical(circleTextColor, this.circleTextColor)) &&
        (circleTextFontWeight == null ||
            identical(circleTextFontWeight, this.circleTextFontWeight)) &&
        (circleTextFontSize == null ||
            identical(circleTextFontSize, this.circleTextFontSize)) &&
        (circleTextLineHeight == null ||
            identical(circleTextLineHeight, this.circleTextLineHeight))) {
      return this;
    }

    return new VantCircleTheme(
      circleTextColor: circleTextColor ?? this.circleTextColor,
      circleTextFontWeight: circleTextFontWeight ?? this.circleTextFontWeight,
      circleTextFontSize: circleTextFontSize ?? this.circleTextFontSize,
      circleTextLineHeight: circleTextLineHeight ?? this.circleTextLineHeight,
    );
  }

  @override
  String toString() {
    return 'VantCircle{circleTextColor: $circleTextColor, circleTextFontWeight: $circleTextFontWeight, circleTextFontSize: $circleTextFontSize, circleTextLineHeight: $circleTextLineHeight}';
  }
}
