import 'package:flutter/material.dart';

class VantColorTheme {
  // Color Palette
  final Color black;
  final Color white;
  final Color red;
  final Color blue;
  final Color orange;
  final Color orangeDark;
  final Color green;
  final Color orangeLight;
  final Color gray1;
  final Color gray2;
  final Color gray3;
  final Color gray4;
  final Color gray5;
  final Color gray6;
  final Color gray7;
  final Color gray8;

  // Gradient Colors
  final LinearGradient gradientRed;
  final LinearGradient gradientOrange;

  // Component Colors
  final Color textColor;
  final Color activeColor;
  final double activeOpacity;
  final double disabledOpacity;
  final Color backgroundColor;
  final Color backgroundColorLight;

  const VantColorTheme({
    @required this.black,
    @required this.white,
    @required this.red,
    @required this.blue,
    @required this.orange,
    @required this.orangeDark,
    @required this.green,
    @required this.orangeLight,
    @required this.gray1,
    @required this.gray2,
    @required this.gray3,
    @required this.gray4,
    @required this.gray5,
    @required this.gray6,
    @required this.gray7,
    @required this.gray8,
    @required this.gradientRed,
    @required this.gradientOrange,
    @required this.textColor,
    @required this.activeColor,
    @required this.activeOpacity,
    @required this.disabledOpacity,
    @required this.backgroundColor,
    @required this.backgroundColorLight,
  });

  VantColorTheme copyWith({
    Color black,
    Color white,
    Color red,
    Color blue,
    Color orange,
    Color orangeDark,
    Color green,
    Color orangeLight,
    Color gray1,
    Color gray2,
    Color gray3,
    Color gray4,
    Color gray5,
    Color gray6,
    Color gray7,
    Color gray8,
    LinearGradient gradientRed,
    LinearGradient gradientOrange,
    Color textColor,
    Color activeColor,
    double activeOpacity,
    double disabledOpacity,
    Color backgroundColor,
    Color backgroundColorLight,
  }) {
    if ((black == null || identical(black, this.black)) &&
        (white == null || identical(white, this.white)) &&
        (red == null || identical(red, this.red)) &&
        (blue == null || identical(blue, this.blue)) &&
        (orange == null || identical(orange, this.orange)) &&
        (orangeDark == null || identical(orangeDark, this.orangeDark)) &&
        (green == null || identical(green, this.green)) &&
        (orangeLight == null || identical(orangeLight, this.orangeLight)) &&
        (gray1 == null || identical(gray1, this.gray1)) &&
        (gray2 == null || identical(gray2, this.gray2)) &&
        (gray3 == null || identical(gray3, this.gray3)) &&
        (gray4 == null || identical(gray4, this.gray4)) &&
        (gray5 == null || identical(gray5, this.gray5)) &&
        (gray6 == null || identical(gray6, this.gray6)) &&
        (gray7 == null || identical(gray7, this.gray7)) &&
        (gray8 == null || identical(gray8, this.gray8)) &&
        (gradientRed == null || identical(gradientRed, this.gradientRed)) &&
        (gradientOrange == null ||
            identical(gradientOrange, this.gradientOrange)) &&
        (textColor == null || identical(textColor, this.textColor)) &&
        (activeColor == null || identical(activeColor, this.activeColor)) &&
        (activeOpacity == null ||
            identical(activeOpacity, this.activeOpacity)) &&
        (disabledOpacity == null ||
            identical(disabledOpacity, this.disabledOpacity)) &&
        (backgroundColor == null ||
            identical(backgroundColor, this.backgroundColor)) &&
        (backgroundColorLight == null ||
            identical(backgroundColorLight, this.backgroundColorLight))) {
      return this;
    }

    return new VantColorTheme(
      black: black ?? this.black,
      white: white ?? this.white,
      red: red ?? this.red,
      blue: blue ?? this.blue,
      orange: orange ?? this.orange,
      orangeDark: orangeDark ?? this.orangeDark,
      green: green ?? this.green,
      orangeLight: orangeLight ?? this.orangeLight,
      gray1: gray1 ?? this.gray1,
      gray2: gray2 ?? this.gray2,
      gray3: gray3 ?? this.gray3,
      gray4: gray4 ?? this.gray4,
      gray5: gray5 ?? this.gray5,
      gray6: gray6 ?? this.gray6,
      gray7: gray7 ?? this.gray7,
      gray8: gray8 ?? this.gray8,
      gradientRed: gradientRed ?? this.gradientRed,
      gradientOrange: gradientOrange ?? this.gradientOrange,
      textColor: textColor ?? this.textColor,
      activeColor: activeColor ?? this.activeColor,
      activeOpacity: activeOpacity ?? this.activeOpacity,
      disabledOpacity: disabledOpacity ?? this.disabledOpacity,
      backgroundColor: backgroundColor ?? this.backgroundColor,
      backgroundColorLight: backgroundColorLight ?? this.backgroundColorLight,
    );
  }

  @override
  String toString() {
    return 'VantColor{black: $black, white: $white, red: $red, blue: $blue, orange: $orange, orangeDark: $orangeDark, green: $green, orangeLight: $orangeLight, gray1: $gray1, gray2: $gray2, gray3: $gray3, gray4: $gray4, gray5: $gray5, gray6: $gray6, gray7: $gray7, gray8: $gray8, gradientRed: $gradientRed, gradientOrange: $gradientOrange, textColor: $textColor, activeColor: $activeColor, activeOpacity: $activeOpacity, disabledOpacity: $disabledOpacity, backgroundColor: $backgroundColor, backgroundColorLight: $backgroundColorLight}';
  }
}
