import 'package:flutter/material.dart';

class VantEmptyTheme {
  final EdgeInsets emptyPadding;
  final double emptyImageSize;
  final double emptyDescriptionMarginTop;
  final EdgeInsets emptyDescriptionPadding;
  final Color emptyDescriptionColor;
  final double emptyDescriptionFontSize;
  final double emptyDescriptionLineHeight;
  final double emptyBottomMarginTop;

  const VantEmptyTheme({
    @required this.emptyPadding,
    @required this.emptyImageSize,
    @required this.emptyDescriptionMarginTop,
    @required this.emptyDescriptionPadding,
    @required this.emptyDescriptionColor,
    @required this.emptyDescriptionFontSize,
    @required this.emptyDescriptionLineHeight,
    @required this.emptyBottomMarginTop,
  });

  VantEmptyTheme copyWith({
    double emptyPadding,
    double emptyImageSize,
    double emptyDescriptionMarginTop,
    double emptyDescriptionPadding,
    Color emptyDescriptionColor,
    double emptyDescriptionFontSize,
    double emptyDescriptionLineHeight,
    double emptyBottomMarginTop,
  }) {
    if ((emptyPadding == null || identical(emptyPadding, this.emptyPadding)) &&
        (emptyImageSize == null ||
            identical(emptyImageSize, this.emptyImageSize)) &&
        (emptyDescriptionMarginTop == null ||
            identical(
                emptyDescriptionMarginTop, this.emptyDescriptionMarginTop)) &&
        (emptyDescriptionPadding == null ||
            identical(emptyDescriptionPadding, this.emptyDescriptionPadding)) &&
        (emptyDescriptionColor == null ||
            identical(emptyDescriptionColor, this.emptyDescriptionColor)) &&
        (emptyDescriptionFontSize == null ||
            identical(
                emptyDescriptionFontSize, this.emptyDescriptionFontSize)) &&
        (emptyDescriptionLineHeight == null ||
            identical(
                emptyDescriptionLineHeight, this.emptyDescriptionLineHeight)) &&
        (emptyBottomMarginTop == null ||
            identical(emptyBottomMarginTop, this.emptyBottomMarginTop))) {
      return this;
    }

    return new VantEmptyTheme(
      emptyPadding: emptyPadding ?? this.emptyPadding,
      emptyImageSize: emptyImageSize ?? this.emptyImageSize,
      emptyDescriptionMarginTop:
          emptyDescriptionMarginTop ?? this.emptyDescriptionMarginTop,
      emptyDescriptionPadding:
          emptyDescriptionPadding ?? this.emptyDescriptionPadding,
      emptyDescriptionColor:
          emptyDescriptionColor ?? this.emptyDescriptionColor,
      emptyDescriptionFontSize:
          emptyDescriptionFontSize ?? this.emptyDescriptionFontSize,
      emptyDescriptionLineHeight:
          emptyDescriptionLineHeight ?? this.emptyDescriptionLineHeight,
      emptyBottomMarginTop: emptyBottomMarginTop ?? this.emptyBottomMarginTop,
    );
  }

  @override
  String toString() {
    return 'VantEmpty{emptyPadding: $emptyPadding, emptyImageSize: $emptyImageSize, emptyDescriptionMarginTop: $emptyDescriptionMarginTop, emptyDescriptionPadding: $emptyDescriptionPadding, emptyDescriptionColor: $emptyDescriptionColor, emptyDescriptionFontSize: $emptyDescriptionFontSize, emptyDescriptionLineHeight: $emptyDescriptionLineHeight, emptyBottomMarginTop: $emptyBottomMarginTop}';
  }
}
