import 'package:flutter/material.dart';

class VantFieldTheme {
  final double fieldLabelWidth;
  final Color fieldLabelColor;
  final double fieldLabelMarginRight;
  final Color fieldInputTextColor;
  final Color fieldInputErrorTextColor;
  final Color fieldInputDisabledTextColor;
  final Color fieldPlaceholderTextColor;
  final double fieldIconSize;
  final double fieldClearIconSize;
  final Color fieldClearIconColor;
  final Color fieldRightIconColor;
  final Color fieldErrorMessageColor;
  final double fieldErrorMessageTextSize;
  final double fieldTextAreaMinHeight;
  final Color fieldWordLimitColor;
  final Color fieldRequiredColor;
  final double fieldWordLimitFontSize;
  final double fieldWordLimitLineHeight;
  final Color fieldDisabledTextColor;

  VantFieldTheme({
    this.fieldLabelWidth,
    this.fieldRequiredColor,
    this.fieldLabelColor,
    this.fieldLabelMarginRight,
    this.fieldInputTextColor,
    this.fieldInputErrorTextColor,
    this.fieldInputDisabledTextColor,
    this.fieldPlaceholderTextColor,
    this.fieldIconSize,
    this.fieldClearIconSize,
    this.fieldClearIconColor,
    this.fieldRightIconColor,
    this.fieldErrorMessageColor,
    this.fieldErrorMessageTextSize,
    this.fieldTextAreaMinHeight,
    this.fieldWordLimitColor,
    this.fieldWordLimitFontSize,
    this.fieldWordLimitLineHeight,
    this.fieldDisabledTextColor,
  });

  VantFieldTheme copyWith({
    double fieldLabelWidth,
    Color fieldLabelColor,
    double fieldLabelMarginRight,
    Color fieldInputTextColor,
    Color fieldInputErrorTextColor,
    Color fieldInputDisabledTextColor,
    Color fieldPlaceholderTextColor,
    double fieldIconSize,
    double fieldClearIconSize,
    Color fieldClearIconColor,
    Color fieldRightIconColor,
    Color fieldErrorMessageColor,
    double fieldErrorMessageTextSize,
    double fieldTextAreaMinHeight,
    Color fieldWordLimitColor,
    Color fieldRequiredColor,
    double fieldWordLimitFontSize,
    double fieldWordLimitLineHeight,
    Color fieldDisabledTextColor,
  }) {
    if ((fieldLabelWidth == null ||
            identical(fieldLabelWidth, this.fieldLabelWidth)) &&
        (fieldLabelColor == null ||
            identical(fieldLabelColor, this.fieldLabelColor)) &&
        (fieldLabelMarginRight == null ||
            identical(fieldLabelMarginRight, this.fieldLabelMarginRight)) &&
        (fieldInputTextColor == null ||
            identical(fieldInputTextColor, this.fieldInputTextColor)) &&
        (fieldInputErrorTextColor == null ||
            identical(
                fieldInputErrorTextColor, this.fieldInputErrorTextColor)) &&
        (fieldInputDisabledTextColor == null ||
            identical(fieldInputDisabledTextColor,
                this.fieldInputDisabledTextColor)) &&
        (fieldPlaceholderTextColor == null ||
            identical(
                fieldPlaceholderTextColor, this.fieldPlaceholderTextColor)) &&
        (fieldIconSize == null ||
            identical(fieldIconSize, this.fieldIconSize)) &&
        (fieldClearIconSize == null ||
            identical(fieldClearIconSize, this.fieldClearIconSize)) &&
        (fieldClearIconColor == null ||
            identical(fieldClearIconColor, this.fieldClearIconColor)) &&
        (fieldRightIconColor == null ||
            identical(fieldRightIconColor, this.fieldRightIconColor)) &&
        (fieldErrorMessageColor == null ||
            identical(fieldErrorMessageColor, this.fieldErrorMessageColor)) &&
        (fieldErrorMessageTextSize == null ||
            identical(
                fieldErrorMessageTextSize, this.fieldErrorMessageTextSize)) &&
        (fieldTextAreaMinHeight == null ||
            identical(fieldTextAreaMinHeight, this.fieldTextAreaMinHeight)) &&
        (fieldWordLimitColor == null ||
            identical(fieldWordLimitColor, this.fieldWordLimitColor)) &&
        (fieldRequiredColor == null ||
            identical(fieldRequiredColor, this.fieldRequiredColor)) &&
        (fieldWordLimitFontSize == null ||
            identical(fieldWordLimitFontSize, this.fieldWordLimitFontSize)) &&
        (fieldWordLimitLineHeight == null ||
            identical(
                fieldWordLimitLineHeight, this.fieldWordLimitLineHeight)) &&
        (fieldDisabledTextColor == null ||
            identical(fieldDisabledTextColor, this.fieldDisabledTextColor))) {
      return this;
    }

    return new VantFieldTheme(
      fieldLabelWidth: fieldLabelWidth ?? this.fieldLabelWidth,
      fieldLabelColor: fieldLabelColor ?? this.fieldLabelColor,
      fieldLabelMarginRight:
          fieldLabelMarginRight ?? this.fieldLabelMarginRight,
      fieldInputTextColor: fieldInputTextColor ?? this.fieldInputTextColor,
      fieldInputErrorTextColor:
          fieldInputErrorTextColor ?? this.fieldInputErrorTextColor,
      fieldInputDisabledTextColor:
          fieldInputDisabledTextColor ?? this.fieldInputDisabledTextColor,
      fieldPlaceholderTextColor:
          fieldPlaceholderTextColor ?? this.fieldPlaceholderTextColor,
      fieldIconSize: fieldIconSize ?? this.fieldIconSize,
      fieldClearIconSize: fieldClearIconSize ?? this.fieldClearIconSize,
      fieldClearIconColor: fieldClearIconColor ?? this.fieldClearIconColor,
      fieldRightIconColor: fieldRightIconColor ?? this.fieldRightIconColor,
      fieldErrorMessageColor:
          fieldErrorMessageColor ?? this.fieldErrorMessageColor,
      fieldErrorMessageTextSize:
          fieldErrorMessageTextSize ?? this.fieldErrorMessageTextSize,
      fieldTextAreaMinHeight:
          fieldTextAreaMinHeight ?? this.fieldTextAreaMinHeight,
      fieldWordLimitColor: fieldWordLimitColor ?? this.fieldWordLimitColor,
      fieldRequiredColor: fieldRequiredColor ?? this.fieldRequiredColor,
      fieldWordLimitFontSize:
          fieldWordLimitFontSize ?? this.fieldWordLimitFontSize,
      fieldWordLimitLineHeight:
          fieldWordLimitLineHeight ?? this.fieldWordLimitLineHeight,
      fieldDisabledTextColor:
          fieldDisabledTextColor ?? this.fieldDisabledTextColor,
    );
  }
}
