import 'package:flutter/material.dart';

class VantFontTheme {
  final double fontSizeXs;
  final double fontSizeSm;
  final double fontSizeMd;
  final double fontSizeLg;
  final double fontWeightBold;

  const VantFontTheme({
    @required this.fontSizeXs,
    @required this.fontSizeSm,
    @required this.fontSizeMd,
    @required this.fontSizeLg,
    @required this.fontWeightBold,
  });

  VantFontTheme copyWith({
    double fontSizeXs,
    double fontSizeSm,
    double fontSizeMd,
    double fontSizeLg,
    double fontWeightBold,
  }) {
    if ((fontSizeXs == null || identical(fontSizeXs, this.fontSizeXs)) &&
        (fontSizeSm == null || identical(fontSizeSm, this.fontSizeSm)) &&
        (fontSizeMd == null || identical(fontSizeMd, this.fontSizeMd)) &&
        (fontSizeLg == null || identical(fontSizeLg, this.fontSizeLg)) &&
        (fontWeightBold == null ||
            identical(fontWeightBold, this.fontWeightBold))) {
      return this;
    }

    return new VantFontTheme(
      fontSizeXs: fontSizeXs ?? this.fontSizeXs,
      fontSizeSm: fontSizeSm ?? this.fontSizeSm,
      fontSizeMd: fontSizeMd ?? this.fontSizeMd,
      fontSizeLg: fontSizeLg ?? this.fontSizeLg,
      fontWeightBold: fontWeightBold ?? this.fontWeightBold,
    );
  }
}
