import 'package:flutter/material.dart';

class VantNotifyTheme{
  final Color notifyTextColor;
  final double notifyPadding;
  final double notifyFontSize;
  final double notifyLineHeight;
  final Color notifyPrimaryBackgroundColor;
  final Color notifySuccessBackgroundColor;
  final Color notifyDangerBackgroundColor;
  final Color notifyWarningBackgroundColor;

  const VantNotifyTheme({
    @required this.notifyTextColor,
    @required this.notifyPadding,
    @required this.notifyFontSize,
    @required this.notifyLineHeight,
    @required this.notifyPrimaryBackgroundColor,
    @required this.notifySuccessBackgroundColor,
    @required this.notifyDangerBackgroundColor,
    @required this.notifyWarningBackgroundColor,
  });

  VantNotifyTheme copyWith({
    Color notifyTextColor,
    double notifyPadding,
    double notifyFontSize,
    double notifyLineHeight,
    Color notifyPrimaryBackgroundColor,
    Color notifySuccessBackgroundColor,
    Color notifyDangerBackgroundColor,
    Color notifyWarningBackgroundColor,
  }) {
    if ((notifyTextColor == null ||
            identical(notifyTextColor, this.notifyTextColor)) &&
        (notifyPadding == null ||
            identical(notifyPadding, this.notifyPadding)) &&
        (notifyFontSize == null ||
            identical(notifyFontSize, this.notifyFontSize)) &&
        (notifyLineHeight == null ||
            identical(notifyLineHeight, this.notifyLineHeight)) &&
        (notifyPrimaryBackgroundColor == null ||
            identical(notifyPrimaryBackgroundColor,
                this.notifyPrimaryBackgroundColor)) &&
        (notifySuccessBackgroundColor == null ||
            identical(notifySuccessBackgroundColor,
                this.notifySuccessBackgroundColor)) &&
        (notifyDangerBackgroundColor == null ||
            identical(notifyDangerBackgroundColor,
                this.notifyDangerBackgroundColor)) &&
        (notifyWarningBackgroundColor == null ||
            identical(notifyWarningBackgroundColor,
                this.notifyWarningBackgroundColor))) {
      return this;
    }

    return new VantNotifyTheme(
      notifyTextColor: notifyTextColor ?? this.notifyTextColor,
      notifyPadding: notifyPadding ?? this.notifyPadding,
      notifyFontSize: notifyFontSize ?? this.notifyFontSize,
      notifyLineHeight: notifyLineHeight ?? this.notifyLineHeight,
      notifyPrimaryBackgroundColor:
          notifyPrimaryBackgroundColor ?? this.notifyPrimaryBackgroundColor,
      notifySuccessBackgroundColor:
          notifySuccessBackgroundColor ?? this.notifySuccessBackgroundColor,
      notifyDangerBackgroundColor:
          notifyDangerBackgroundColor ?? this.notifyDangerBackgroundColor,
      notifyWarningBackgroundColor:
          notifyWarningBackgroundColor ?? this.notifyWarningBackgroundColor,
    );
  }

  @override
  String toString() {
    return 'VantNotify{notifyTextColor: $notifyTextColor, notifyPadding: $notifyPadding, notifyFontSize: $notifyFontSize, notifyLineHeight: $notifyLineHeight, notifyPrimaryBackgroundColor: $notifyPrimaryBackgroundColor, notifySuccessBackgroundColor: $notifySuccessBackgroundColor, notifyDangerBackgroundColor: $notifyDangerBackgroundColor, notifyWarningBackgroundColor: $notifyWarningBackgroundColor}';
  }
}