import 'package:flutter/material.dart';

class VantPaddingTheme {
  final double paddingBase;
  final double paddingXs;
  final double paddingSm;
  final double paddingMd;
  final double paddingLg;
  final double paddingXl;

  const VantPaddingTheme({
    @required this.paddingBase,
    @required this.paddingXs,
    @required this.paddingSm,
    @required this.paddingMd,
    @required this.paddingLg,
    @required this.paddingXl,
  });

  VantPaddingTheme copyWith({
    double paddingBase,
    double paddingXs,
    double paddingSm,
    double paddingMd,
    double paddingLg,
    double paddingXl,
  }) {
    if ((paddingBase == null || identical(paddingBase, this.paddingBase)) &&
        (paddingXs == null || identical(paddingXs, this.paddingXs)) &&
        (paddingSm == null || identical(paddingSm, this.paddingSm)) &&
        (paddingMd == null || identical(paddingMd, this.paddingMd)) &&
        (paddingLg == null || identical(paddingLg, this.paddingLg)) &&
        (paddingXl == null || identical(paddingXl, this.paddingXl))) {
      return this;
    }

    return new VantPaddingTheme(
      paddingBase: paddingBase ?? this.paddingBase,
      paddingXs: paddingXs ?? this.paddingXs,
      paddingSm: paddingSm ?? this.paddingSm,
      paddingMd: paddingMd ?? this.paddingMd,
      paddingLg: paddingLg ?? this.paddingLg,
      paddingXl: paddingXl ?? this.paddingXl,
    );
  }

  @override
  String toString() {
    return 'VantPadding{paddingBase: $paddingBase, paddingXs: $paddingXs, paddingSm: $paddingSm, paddingMd: $paddingMd, paddingLg: $paddingLg, paddingXl: $paddingXl}';
  }
}
