import 'package:flutter/material.dart';

class VantPaginationTheme {
  final double paginationHeight;
  final double paginationFontSize;
  final double paginationItemWidth;
  final Color paginationItemDefaultColor;
  final Color paginationItemDisabledColor;
  final Color paginationItemDisabledBackgroundColor;
  final Color paginationBackgroundColor;
  final Color paginationDescColor;
  final double paginationDisabledOpacity;

  const VantPaginationTheme({
    @required this.paginationHeight,
    @required this.paginationFontSize,
    @required this.paginationItemWidth,
    @required this.paginationItemDefaultColor,
    @required this.paginationItemDisabledColor,
    @required this.paginationItemDisabledBackgroundColor,
    @required this.paginationBackgroundColor,
    @required this.paginationDescColor,
    @required this.paginationDisabledOpacity,
  });

  VantPaginationTheme copyWith({
    double paginationHeight,
    double paginationFontSize,
    double paginationItemWidth,
    Color paginationItemDefaultColor,
    Color paginationItemDisabledColor,
    Color paginationItemDisabledBackgroundColor,
    Color paginationBackgroundColor,
    Color paginationDescColor,
    double paginationDisabledOpacity,
  }) {
    if ((paginationHeight == null ||
            identical(paginationHeight, this.paginationHeight)) &&
        (paginationFontSize == null ||
            identical(paginationFontSize, this.paginationFontSize)) &&
        (paginationItemWidth == null ||
            identical(paginationItemWidth, this.paginationItemWidth)) &&
        (paginationItemDefaultColor == null ||
            identical(
                paginationItemDefaultColor, this.paginationItemDefaultColor)) &&
        (paginationItemDisabledColor == null ||
            identical(paginationItemDisabledColor,
                this.paginationItemDisabledColor)) &&
        (paginationItemDisabledBackgroundColor == null ||
            identical(paginationItemDisabledBackgroundColor,
                this.paginationItemDisabledBackgroundColor)) &&
        (paginationBackgroundColor == null ||
            identical(
                paginationBackgroundColor, this.paginationBackgroundColor)) &&
        (paginationDescColor == null ||
            identical(paginationDescColor, this.paginationDescColor)) &&
        (paginationDisabledOpacity == null ||
            identical(
                paginationDisabledOpacity, this.paginationDisabledOpacity))) {
      return this;
    }

    return new VantPaginationTheme(
      paginationHeight: paginationHeight ?? this.paginationHeight,
      paginationFontSize: paginationFontSize ?? this.paginationFontSize,
      paginationItemWidth: paginationItemWidth ?? this.paginationItemWidth,
      paginationItemDefaultColor:
          paginationItemDefaultColor ?? this.paginationItemDefaultColor,
      paginationItemDisabledColor:
          paginationItemDisabledColor ?? this.paginationItemDisabledColor,
      paginationItemDisabledBackgroundColor:
          paginationItemDisabledBackgroundColor ??
              this.paginationItemDisabledBackgroundColor,
      paginationBackgroundColor:
          paginationBackgroundColor ?? this.paginationBackgroundColor,
      paginationDescColor: paginationDescColor ?? this.paginationDescColor,
      paginationDisabledOpacity:
          paginationDisabledOpacity ?? this.paginationDisabledOpacity,
    );
  }

  @override
  String toString() {
    return 'VantPagination{paginationHeight: $paginationHeight, paginationFontSize: $paginationFontSize, paginationItemWidth: $paginationItemWidth, paginationItemDefaultColor: $paginationItemDefaultColor, paginationItemDisabledColor: $paginationItemDisabledColor, paginationItemDisabledBackgroundColor: $paginationItemDisabledBackgroundColor, paginationBackgroundColor: $paginationBackgroundColor, paginationDescColor: $paginationDescColor, paginationDisabledOpacity: $paginationDisabledOpacity}';
  }
}
