import 'package:flutter/material.dart';

class VantSearchTheme{
  final double searchPadding;
  final Color searchBackgroundColor;
  final Color searchContentBackgroundColor;
  final double searchInputHeight;
  final double searchLabelPadding;
  final Color searchLabelColor;
  final double searchLabelFontSize;
  final Color searchLeftIconColor;
  final double searchActionPadding;
  final Color searchActionTextColor;
  final double searchActionFontSize;

  const VantSearchTheme({
    @required this.searchPadding,
    @required this.searchBackgroundColor,
    @required this.searchContentBackgroundColor,
    @required this.searchInputHeight,
    @required this.searchLabelPadding,
    @required this.searchLabelColor,
    @required this.searchLabelFontSize,
    @required this.searchLeftIconColor,
    @required this.searchActionPadding,
    @required this.searchActionTextColor,
    @required this.searchActionFontSize,
  });

  VantSearchTheme copyWith({
    double searchPadding,
    Color searchBackgroundColor,
    Color searchContentBackgroundColor,
    double searchInputHeight,
    double searchLabelPadding,
    Color searchLabelColor,
    double searchLabelFontSize,
    Color searchLeftIconColor,
    double searchActionPadding,
    Color searchActionTextColor,
    double searchActionFontSize,
  }) {
    if ((searchPadding == null ||
            identical(searchPadding, this.searchPadding)) &&
        (searchBackgroundColor == null ||
            identical(searchBackgroundColor, this.searchBackgroundColor)) &&
        (searchContentBackgroundColor == null ||
            identical(searchContentBackgroundColor,
                this.searchContentBackgroundColor)) &&
        (searchInputHeight == null ||
            identical(searchInputHeight, this.searchInputHeight)) &&
        (searchLabelPadding == null ||
            identical(searchLabelPadding, this.searchLabelPadding)) &&
        (searchLabelColor == null ||
            identical(searchLabelColor, this.searchLabelColor)) &&
        (searchLabelFontSize == null ||
            identical(searchLabelFontSize, this.searchLabelFontSize)) &&
        (searchLeftIconColor == null ||
            identical(searchLeftIconColor, this.searchLeftIconColor)) &&
        (searchActionPadding == null ||
            identical(searchActionPadding, this.searchActionPadding)) &&
        (searchActionTextColor == null ||
            identical(searchActionTextColor, this.searchActionTextColor)) &&
        (searchActionFontSize == null ||
            identical(searchActionFontSize, this.searchActionFontSize))) {
      return this;
    }

    return new VantSearchTheme(
      searchPadding: searchPadding ?? this.searchPadding,
      searchBackgroundColor:
          searchBackgroundColor ?? this.searchBackgroundColor,
      searchContentBackgroundColor:
          searchContentBackgroundColor ?? this.searchContentBackgroundColor,
      searchInputHeight: searchInputHeight ?? this.searchInputHeight,
      searchLabelPadding: searchLabelPadding ?? this.searchLabelPadding,
      searchLabelColor: searchLabelColor ?? this.searchLabelColor,
      searchLabelFontSize: searchLabelFontSize ?? this.searchLabelFontSize,
      searchLeftIconColor: searchLeftIconColor ?? this.searchLeftIconColor,
      searchActionPadding: searchActionPadding ?? this.searchActionPadding,
      searchActionTextColor:
          searchActionTextColor ?? this.searchActionTextColor,
      searchActionFontSize: searchActionFontSize ?? this.searchActionFontSize,
    );
  }

  @override
  String toString() {
    return 'VantSearch{searchPadding: $searchPadding, searchBackgroundColor: $searchBackgroundColor, searchContentBackgroundColor: $searchContentBackgroundColor, searchInputHeight: $searchInputHeight, searchLabelPadding: $searchLabelPadding, searchLabelColor: $searchLabelColor, searchLabelFontSize: $searchLabelFontSize, searchLeftIconColor: $searchLeftIconColor, searchActionPadding: $searchActionPadding, searchActionTextColor: $searchActionTextColor, searchActionFontSize: $searchActionFontSize}';
  }
}