import 'package:flutter/material.dart';
import 'package:vant/src/theme/theme.dart';

class VantUI extends StatefulWidget {
  final VantThemeData theme;
  final Widget child;

  VantUI({Key key, @required this.child, this.theme}) : super(key: key);

  @override
  _VantUIState createState() => _VantUIState();
}

class _VantUIState extends State<VantUI> {
  @override
  Widget build(BuildContext context) {
    final theme = this._getTheme(context, this.widget.theme);

    return VantTheme(data: theme, child: this.widget.child);
  }

  VantThemeData _getTheme(BuildContext context, VantThemeData themeData) {
    final defaultTheme = VantThemeData.getDefaultTheme(Theme.of(context));

    final theme = defaultTheme.copyWith(
      button: defaultTheme?.button?.copyWith(
        buttonInfoColor: defaultTheme?.button?.buttonInfoColor,
        buttonMiniHeight: defaultTheme?.button?.buttonMiniHeight,
        buttonDangerColor: defaultTheme?.button?.buttonDangerColor,
        buttonLargeHeight: defaultTheme?.button?.buttonLargeHeight,
        buttonSmallHeight: defaultTheme?.button?.buttonSmallHeight,
        buttonBorderWidth: defaultTheme?.button?.buttonBorderWidth,
        buttonBorderRadius: defaultTheme?.button?.buttonBorderRadius,
        buttonWarningColor: defaultTheme?.button?.buttonWarningColor,
        buttonMiniFontSize: defaultTheme?.button?.buttonMiniFontSize,
        buttonDefaultColor: defaultTheme?.button?.buttonDefaultColor,
        buttonPrimaryColor: defaultTheme?.button?.buttonPrimaryColor,
        buttonSmallFontSize: defaultTheme?.button?.buttonSmallFontSize,
        buttonDefaultHeight: defaultTheme?.button?.buttonDefaultHeight,
        buttonNormalFontSize: defaultTheme?.button?.buttonNormalFontSize,
        buttonHairBorderWidth: defaultTheme?.button?.buttonHairBorderWidth,
        buttonInfoBorderColor: defaultTheme?.button?.buttonInfoBorderColor,
        buttonDefaultFontSize: defaultTheme?.button?.buttonDefaultFontSize,
        buttonDisabledOpacity: defaultTheme?.button?.buttonDisabledOpacity,
        buttonDangerBorderColor: defaultTheme?.button?.buttonDangerBorderColor,
        buttonRoundBorderRadius: defaultTheme?.button?.buttonRoundBorderRadius,
        buttonDefaultLineHeight: defaultTheme?.button?.buttonDefaultLineHeight,
        buttonWarningBorderColor:
            defaultTheme?.button?.buttonWarningBorderColor,
        buttonDefaultBorderColor:
            defaultTheme?.button?.buttonDefaultBorderColor,
        buttonPrimaryBorderColor:
            defaultTheme?.button?.buttonPrimaryBorderColor,
        buttonInfoBackgroundColor:
            defaultTheme?.button?.buttonInfoBackgroundColor,
        buttonPlainBackgroundColor:
            defaultTheme?.button?.buttonPlainBackgroundColor,
        buttonDangerBackgroundColor:
            defaultTheme?.button?.buttonDangerBackgroundColor,
        buttonDefaultBackgroundColor:
            defaultTheme?.button?.buttonDefaultBackgroundColor,
        buttonPrimaryBackgroundColor:
            defaultTheme?.button?.buttonPrimaryBackgroundColor,
        buttonWarningBackgroundColor:
            defaultTheme?.button?.buttonWarningBackgroundColor,
      ),
      cell: defaultTheme?.cell?.copyWith(
        cellFontSize: themeData?.cell?.cellFontSize,
        cellIconSize: themeData?.cell?.cellIconSize,
        cellTextColor: themeData?.cell?.cellTextColor,
        cellValueColor: themeData?.cell?.cellValueColor,
        cellLineHeight: themeData?.cell?.cellLineHeight,
        cellLabelColor: themeData?.cell?.cellLabelColor,
        cellBorderColor: themeData?.cell?.cellBorderColor,
        cellActiveColor: themeData?.cell?.cellActiveColor,
        cellRequiredColor: themeData?.cell?.cellRequiredColor,
        cellLabelFontSize: themeData?.cell?.cellLabelFontSize,
        cellLabelMarginTop: themeData?.cell?.cellLabelMarginTop,
        cellRightIconColor: themeData?.cell?.cellRightIconColor,
        cellVerticalPadding: themeData?.cell?.cellVerticalPadding,
        cellBackgroundColor: themeData?.cell?.cellBackgroundColor,
        cellLabelLineHeight: themeData?.cell?.cellLabelLineHeight,
        cellHorizontalPadding: themeData?.cell?.cellHorizontalPadding,
        cellLargeTitleFontSize: themeData?.cell?.cellLargeTitleFontSize,
        cellLargeLabelFontSize: themeData?.cell?.cellLargeLabelFontSize,
        cellLargeVerticalPadding: themeData?.cell?.cellLargeVerticalPadding,
      ),
      tag: defaultTheme?.tag?.copyWith(
        tagPadding: themeData?.tag?.tagPadding,
        tagFontSize: themeData?.tag?.tagFontSize,
        tagTextColor: themeData?.tag?.tagTextColor,
        tagDangerColor: themeData?.tag?.tagDangerColor,
        tagBorderRadius: themeData?.tag?.tagBorderRadius,
        tagPrimaryColor: themeData?.tag?.tagPrimaryColor,
        tagSuccessColor: themeData?.tag?.tagSuccessColor,
        tagWarningColor: themeData?.tag?.tagWarningColor,
        tagDefaultColor: themeData?.tag?.tagDefaultColor,
        tagLargeFontSize: themeData?.tag?.tagLargeFontSize,
        tagMediumFontSize: themeData?.tag?.tagMediumFontSize,
        tagRoundBorderRadius: themeData?.tag?.tagRoundBorderRadius,
        tagPlainBackgroundColor: themeData?.tag?.tagPlainBackgroundColor,
      ),
    );

    return theme;
  }
}
